# -*- coding: utf-8 -*-
#
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
#  Noctua vagus - An adventure game with an owl as a main character         # .
#  Copyright (C) 2010  Lukáš Machyán (Phobulos@gmail.com)                   # .
#                                  (http://phobulos.wz.cz)                  # .
#                                                                           # .
#  This program is free software: you can redistribute it and/or modify     # .
#  it under the terms of the GNU General Public License as published by     # .
#  the Free Software Foundation, either version 3 of the License, or        # .
#  (at your option) any later version.                                      # .
#                                                                           # .
#  This program is distributed in the hope that it will be useful,          # .
#  but WITHOUT ANY WARRANTY; without even the implied warranty of           # .
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            # .
#  GNU General Public License for more details.                             # .
#                                                                           # .
#  You should have received a copy of the GNU General Public License        # .
#  along with this program. If not, see <http://www.gnu.org/licenses/>.     # .
#                                                                           # .
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # .
# . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .

import os, ConfigParser
from pygame.locals import *

import main

def write_config(soubor):
    # Keys written to file aren't sorted alphabetically (in Python 2.7 should be - maybe import collections.OrderedDict needed)
    config = ConfigParser.SafeConfigParser()
    
    config.add_section("controls")
    config.set("controls", "left", str(main.ovladaci_klavesy[3]))
    config.set("controls", "right", str(main.ovladaci_klavesy[1]))
    config.set("controls", "up", str(main.ovladaci_klavesy[2]))
    config.set("controls", "down", str(main.ovladaci_klavesy[4]))
    config.set("controls", "speed", str(main.ovladaci_klavesy[5]))
    config.set("controls", "hoot1", str(main.ovladaci_klavesy[6]))
    config.set("controls", "hoot2", str(main.ovladaci_klavesy[7]))
    config.set("controls", "hoot3", str(main.ovladaci_klavesy[8]))
    config.set("controls", "subject_action", str(main.ovladaci_klavesy[9]))
    config.set("controls", "objectives", str(main.ovladaci_klavesy[10]))
    config.set("controls", "screenshot", str(main.ovladaci_klavesy[11]))
    config.set("controls", "speed_alt", str(K_RSHIFT))
    config.set("controls", "exit", str(K_ESCAPE))
    
    config.add_section("options")
    config.set("options", "font_color", str(main.font_color[0]) + "," + str(main.font_color[1]) + "," + str(main.font_color[2]))
    config.set("options", "font_color_active", str(main.font_color_active[0]) + "," + str(main.font_color_active[1]) + "," + str(main.font_color_active[2]))
    config.set("options", "font_color_link", str(main.font_color_link[0]) + "," + str(main.font_color_link[1]) + "," + str(main.font_color_link[2]))
    config.set("options", "back_color", str(main.back_color[0]) + "," + str(main.back_color[1]) + "," + str(main.back_color[2]) + "," + str(main.back_color[3]))
    config.set("options", "back_color_question", str(main.back_color_question[0]) + "," + str(main.back_color_question[1]) + "," + str(main.back_color_question[2]) + "," + str(main.back_color_question[3]))
    config.set("options", "back_color_objectives", str(main.back_color_objectives[0]) + "," + str(main.back_color_objectives[1]) + "," + str(main.back_color_objectives[2]) + "," + str(main.back_color_objectives[3]))
    config.set("options", "back_color_error", str(main.back_color_error[0]) + "," + str(main.back_color_error[1]) + "," + str(main.back_color_error[2]) + "," + str(main.back_color_error[3]))
    
    config.set("options", "font_name", main.font_name)
    config.set("options", "language", main.language)
    config.set("options", "line_spacing", str(main.line_spacing))
    config.set("options", "line_spacing_small", str(main.line_spacing_small))
    config.set("options", "long_click_delay", str(main.long_click_delay))
    config.set("options", "locale_dir", str(main.locale_dir))
    config.set("options", "max_fps", str(main.max_fps))
    config.set("options", "term", str(main.term))
    
    config.add_section("info")
    config.set("info", "i", "This section isn't important for game configuration. It only provides info about game which generated this file.")
    config.set("info", "game", main.NAME)
    config.set("info", "game_version", main.VERSION)
    config.set("info", "os_name", os.name)
    
    with open(soubor, "w") as configfile:
        config.write(configfile)

def read_config(soubor):
    config = ConfigParser.SafeConfigParser()
    config.read(soubor)
    
    main.ovladaci_klavesy[0] = 0
    main.ovladaci_klavesy[1] = config.getint("controls", "right")
    main.ovladaci_klavesy[2] = config.getint("controls", "up")
    main.ovladaci_klavesy[3] = config.getint("controls", "left")
    main.ovladaci_klavesy[4] = config.getint("controls", "down")
    main.ovladaci_klavesy[5] = config.getint("controls", "speed")
    main.ovladaci_klavesy[6] = config.getint("controls", "hoot1")
    main.ovladaci_klavesy[7] = config.getint("controls", "hoot2")
    main.ovladaci_klavesy[8] = config.getint("controls", "hoot3")
    main.ovladaci_klavesy[9] = config.getint("controls", "subject_action")
    main.ovladaci_klavesy[10] = config.getint("controls", "objectives")
    main.ovladaci_klavesy[11] = config.getint("controls", "screenshot")
    
    # colors loading
    fc = (config.get("options", "font_color").split(","))
    main.font_color = (int(fc[0]), int(fc[1]), int(fc[2]))
    fc = (config.get("options", "font_color_link").split(","))
    main.font_color_link = (int(fc[0]), int(fc[1]), int(fc[2]))
    fc = (config.get("options", "font_color_active").split(","))
    main.font_color_active = (int(fc[0]), int(fc[1]), int(fc[2]))
    fc = (config.get("options", "back_color").split(","))
    main.back_color = (int(fc[0]), int(fc[1]), int(fc[2]), int(fc[3]))
    fc = (config.get("options", "back_color_question").split(","))
    main.back_color_question = (int(fc[0]), int(fc[1]), int(fc[2]), int(fc[3]))
    fc = (config.get("options", "back_color_objectives").split(","))
    main.back_color_objectives = (int(fc[0]), int(fc[1]), int(fc[2]), int(fc[3]))
    fc = (config.get("options", "back_color_error").split(","))
    main.back_color_error = (int(fc[0]), int(fc[1]), int(fc[2]), int(fc[3]))
    del fc
    
    main.font_name = config.get("options", "font_name")
    main.language = config.get("options", "language")
    main.line_spacing = config.getint("options", "line_spacing")
    main.line_spacing_small = config.getint("options", "line_spacing_small")
    main.long_click_delay = config.getint("options", "long_click_delay")
    main.locale_dir = config.get("options", "locale_dir")
    main.max_fps = config.getint("options", "max_fps")
    main.term = config.getboolean("options", "term")
