# -*- coding: utf-8 -*-
#
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
#  Noctua vagus - An adventure game with an owl as a main character         # .
#  Copyright (C) 2010  Lukáš Machyán (Phobulos@gmail.com)                   # .
#                                  (http://phobulos.wz.cz)                  # .
#                                                                           # .
#  This program is free software: you can redistribute it and/or modify     # .
#  it under the terms of the GNU General Public License as published by     # .
#  the Free Software Foundation, either version 3 of the License, or        # .
#  (at your option) any later version.                                      # .
#                                                                           # .
#  This program is distributed in the hope that it will be useful,          # .
#  but WITHOUT ANY WARRANTY; without even the implied warranty of           # .
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            # .
#  GNU General Public License for more details.                             # .
#                                                                           # .
#  You should have received a copy of the GNU General Public License        # .
#  along with this program. If not, see <http://www.gnu.org/licenses/>.     # .
#                                                                           # .
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # .
# . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .

import pygame, os, random, ConfigParser
from pygame.locals import *

import data, files, init
from objects import *
from rooms import *
from menu import *

init.init()
mouse_move = 0
timer = [-1]

# Překryvný barevný průhlednostní filtr
filtr = (pygame.Surface(obrazovka.get_size())).convert_alpha()
filtr.fill(filtr_barvy)

def main():
    random.seed()
    
    end = 0
   
    owl_group.add(sova)
        
    casovac = pygame.time.Clock()

    # Main loop
    while not end:
        casovac.tick(max_fps)
        if timer[0] > 0:
            timer[0] -= 1
        elif timer[0] == 0:
            klavesa[5] = 1 # Timer finished, long press of button took place
            timer[0] = -1

        # Event loop
        if screen_menu == None:             # No overlay screen displayed
            end = event_loop()                  # Default event loop
        else:                               # Overlay screen  displayed
            end = screen_menu.event_loop()      # Screen overlay's event loop
        
        # Jen fps2 udržuje správnou hodnotu fps je tady kvůli nefunkčnosti fps2 pro přepočet rychlosti
        fps = casovac.get_fps()
        global fps2
        fps2 = casovac.get_fps()
#        pygame.display.set_caption('Sova ' + VERSION + ' (' + str(round(fps, 2)) + ' fps) by ' + AUTHOR)

# Updating -------------------------------------------------------------
        # Move control
        if screen_menu == None:
            if not sova.houkani:  # When owl isn't hooting, move
                if mouse_move:
                    sova.move2(pygame.mouse.get_pos())
                else:
                    # Move owl according pressed keys
                    sova.move(klavesa[1], klavesa[2], klavesa[3], klavesa[4], klavesa[5])
            else:  # When owl is hooting, modify hooting emblem
                sova.move_hooting_embl(klavesa[1], klavesa[2], klavesa[3], klavesa[4])
                sova.sprite_appear(0, 0, 0, 0)
          
    # Drawing
        if screen_menu != None:
            if screen_menu.__class__.__name__ == "Error_screen":
                pass
            else:
                drawing()
        else:
            drawing()

#        except:                     # When is not any image loaded drawing won't take place
#            pass                    # but error screen will be shown
        
        if screen_menu != None:
            screen_menu.update()
            obrazovka.blit(screen_menu.pozadi, (0, 0))
        
        pygame.display.flip()  # drawing of everything
    
    # Be IDLE friendly
    pygame.quit()

def drawing():
    # Updating
    sova.update()                   # update owl
    for i in range(len(obj)):       # go through all subjects
        obj[i].update()                 # update all subjects

    obrazovka.blit(room[active_room].pozadi, (0, 0))  # blitting background of current room
                
    group[active_room].draw(obrazovka)  # drawing not held subjects

    owl_group.draw(obrazovka)  # drawing owl and held subject
                
    obrazovka.blit(room[active_room].popredi, (0, 0))  # blitting foreground of current room
    obrazovka.blit(filtr, (0, 0))  # dark/color filter
    data.draw_HUD(obrazovka, (0, 0))
    
    # Drawing emblem of object near to owl
    for i in range(len(group[active_room])):
        if group[active_room].sprites()[i].emblem != None and group[active_room].sprites()[i].rect.colliderect(sova):
            data.draw_emblem(obrazovka, group[active_room].sprites()[i].rect.center, group[active_room].sprites()[i].emblem, col = font_color)
            
    data.draw_emblem(obrazovka, (50, 50), sova.hooting_sequence, col = font_color_active, scale = 1.5)  # Emblem hooted now
    
def event_loop():
    """Basic event loop that occurs during gameplay. It contains e.g. controls of 
    main character."""
    
    for udalost in pygame.event.get():

# Termination request
        if udalost.type == QUIT:
            if term:
                print (_("Termination...").decode(main.CODING))
            return 1

# Keys pressed
        elif udalost.type == KEYDOWN:
            
            global screen_menu
            
            if udalost.key == K_ESCAPE:
                screen_menu = Menu_screen()
                
            elif udalost.key == ovladaci_klavesy[10]:
                if screen_menu == None:
                    screen_menu = Quest_screen()
                    klavesa[1] = klavesa[2] = klavesa[3] = klavesa[4] = 0
                    
            elif udalost.key == ovladaci_klavesy[11]:
                data.make_screenshot()
                    
            elif udalost.key == K_F12:
                if screen_menu == None:
                    screen_menu = Debug_screen()
                    klavesa[1] = klavesa[2] = klavesa[3] = klavesa[4] = 0
                    
#            elif udalost.key == K_e:
#                if screen_menu == None:
#                    screen_menu = Error_screen()
#                    klavesa[1] = klavesa[2] = klavesa[3] = klavesa[4] = 0 
            
            elif udalost.key == ovladaci_klavesy[6]:
                sova.hoot(35, 1)
                
            elif udalost.key == ovladaci_klavesy[7]:
                sova.hoot(45, 2)
                
            elif udalost.key == ovladaci_klavesy[8]:
                sova.hoot(35, 3)
                
            elif udalost.key == K_RSHIFT or udalost.key == ovladaci_klavesy[5]:
                klavesa[5] = 1
                
            elif udalost.key == ovladaci_klavesy[9]:
                sova.take_drop()

            global mouse_move
            if not mouse_move:
                if udalost.key == ovladaci_klavesy[1]:
                    klavesa[1] = 1
                elif udalost.key == ovladaci_klavesy[2]:
                    klavesa[2] = 1
                elif udalost.key == ovladaci_klavesy[3]:
                    klavesa[3] = 1
                elif udalost.key == ovladaci_klavesy[4]:
                    klavesa[4] = 1

# Keys released
        elif udalost.type == KEYUP:
            if udalost.key == ovladaci_klavesy[1]:
                klavesa[1] = 0
            elif udalost.key == ovladaci_klavesy[2]:
                klavesa[2] = 0
            elif udalost.key == ovladaci_klavesy[3]:
                klavesa[3] = 0
            elif udalost.key == ovladaci_klavesy[4]:
                klavesa[4] = 0

            elif udalost.key == K_RSHIFT or udalost.key == ovladaci_klavesy[5]:
                klavesa[5] = 0

 # mouse button pressed        
        elif udalost.type == MOUSEBUTTONDOWN:
            if udalost.button == 3:     # Right button action
                mouse_move = 1
                klavesa[1] = 0          # moving according the mouse
                klavesa[2] = 0          # not according keys
                klavesa[3] = 0
                klavesa[4] = 0
                
            elif udalost.button == 1:   # Left button action
                timer[0] = long_click_delay  # set timer, if button is released 
                            # before ending of timer take/drop action will occur;
                            # speed up action will occur otherwise
            
            elif udalost.button == 2:   # Hooting
                sova.hoot(35, 1)        # ...
                                        #  ...
            elif udalost.button == 4:   #  with
                sova.hoot(45, 2)        #  ...
                                        # ...
            elif udalost.button == 5:   # mouse wheel
                sova.hoot(35, 3)

 # mouse button released
        elif udalost.type == MOUSEBUTTONUP:
            if udalost.button == 1:     # Left
                klavesa[5] = 0          # remove speeding up
                if timer[0] > 0:
                    sova.take_drop()    # subject manipulation
                    timer[0] = -1       # stop timing - no speeding up will occur
                    
            if udalost.button == 3:     # Right
                mouse_move = 0              # Stop moving according the mouse

