# -*- coding: utf-8 -*-
#
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
#  Noctua vagus - An adventure game with an owl as a main character         # .
#  Copyright (C) 2010  Lukáš Machyán (Phobulos@gmail.com)                   # .
#                                  (http://phobulos.wz.cz)                  # .
#                                                                           # .
#  This program is free software: you can redistribute it and/or modify     # .
#  it under the terms of the GNU General Public License as published by     # .
#  the Free Software Foundation, either version 3 of the License, or        # .
#  (at your option) any later version.                                      # .
#                                                                           # .
#  This program is distributed in the hope that it will be useful,          # .
#  but WITHOUT ANY WARRANTY; without even the implied warranty of           # .
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            # .
#  GNU General Public License for more details.                             # .
#                                                                           # .
#  You should have received a copy of the GNU General Public License        # .
#  along with this program. If not, see <http://www.gnu.org/licenses/>.     # .
#                                                                           # .
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # .
# . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .

import pygame, os, random, main, data, datetime, sys, platform, webbrowser
from pygame.locals import *

def game_exit():
    if main.term:
        print (_("Termination...").decode(main.CODING))
    sys.exit()

def menu_action(nr = None):
    if nr == 0:
        game_exit()
        
    elif nr == 1:
        main.screen_menu = None
        
    elif nr == 3:
        main.screen_menu = Info_screen()
        
    elif nr == 4:
        main.screen_menu = Question_exit_screen()
        
    elif nr == 11:
# FIXME: Lines should be divided by program automatically (call some function) optimal and max line length)
        main.screen_menu.caption = _("License").decode(main.CODING)
        main.screen_menu.label_group.empty()
        p_y = 150  # y - position of text - increased after make label
        main.screen_menu.new_label((u"{0} {1}  Copyright (C) {2}  Lukáš Machyán (Phobulos@gmail.com)".format(main.NAME, main.VERSION, main.YEAR)),  500, p_y, font_size = 1); p_y += main.line_spacing_small
        main.screen_menu.new_label(_("This program comes with ABSOLUTELY NO WARRANTY.").decode(main.CODING), 500, p_y, font_size = 1); p_y += main.line_spacing_small
        main.screen_menu.new_label(_("This is free software, and you are welcome to redistribute it under certain conditions.").decode(main.CODING), 500, p_y, font_size = 1); p_y += main.line_spacing_small
        main.screen_menu.new_label(_('More information you will find in a file "COPYING" in the game directory.').decode(main.CODING), 500, p_y, font_size = 1); p_y += main.line_spacing_small
        main.screen_menu.new_label(u"(http://www.gnu.org/licenses/gpl.html)", 500, p_y, font_size = 1); p_y += main.line_spacing_small * 4
        
        main.screen_menu.new_label(_('The licenses for some other parts of the game (not created by game developer):').decode(main.CODING), 500, p_y, font_size = 1); p_y += main.line_spacing_small * 2
        
        main.screen_menu.new_label(_('The font "texgyreadventor-bold.otf" is released under the GUST Font License').decode(main.CODING), 500, p_y, font_size = 1); p_y += main.line_spacing_small
        main.screen_menu.new_label(u"(http://tug.org/fonts/licenses/GUST-FONT-LICENSE.txt)", 500, p_y, font_size = 1); p_y += main.line_spacing_small * 2
        main.screen_menu.new_label(_('Sounds are under Creative Commons Sampling Plus 1.0 License').decode(main.CODING), 500, p_y, font_size = 1); p_y += main.line_spacing_small
        main.screen_menu.new_label(u"(http://creativecommons.org/licenses/sampling+/1.0/)", 500, p_y, font_size = 1); p_y += main.line_spacing_small * 2
        
    elif nr == 12:
        main.screen_menu.caption = _("Credits").decode(main.CODING)
        main.screen_menu.label_group.empty()  # možná i zničit (ve for použít del)
        p_y = 80  # y - position of text - increased after make label
        main.screen_menu.new_label(_("Programing & Graphics").decode(main.CODING), 500, p_y); p_y += main.line_spacing
        main.screen_menu.new_label(u"Lukáš Machyán (Phobulos@gmail.com)", 500, p_y, font_size = 1); p_y += 2 * main.line_spacing
        main.screen_menu.new_label(_("Sounds").decode(main.CODING), 500, p_y); p_y += main.line_spacing
        # License info
        li = (_('From "http://www.freesound.org/" under\nCreative Commons Sampling Plus 1.0 License\n(http://creativecommons.org/licenses/sampling+/1.0/)').decode(main.CODING)).split("\n")
        for i in range(len(li)):
            main.screen_menu.new_label((li[i]), 500, p_y, font_size = 1)
            p_y += main.line_spacing_small
        del li
        p_y += main.line_spacing_small
        main.screen_menu.new_label(u"inchadney (http://www.freesound.org/usersViewSingle.php?id=28867) " + _("(owl's hootings)").decode(main.CODING), 500, p_y, font_size = 1); p_y += main.line_spacing_small
        main.screen_menu.new_label(u"roscoetoon (http://www.freesound.org/usersViewSingle.php?id=186469) " + _("(waterfall)").decode(main.CODING), 500, p_y, font_size = 1); p_y += main.line_spacing_small
        main.screen_menu.new_label(_('(More details in file "AUTHORS" in the game directory)').decode(main.CODING), 500, p_y, font_size = 1);
        p_y += 2 * main.line_spacing
#        main.screen_menu.new_label(u"Will be added soon.", 500, p_y, font_size = 1); p_y += 2 * main.line_spacing
        if main.translators != "translator-credits":  # show only for non-english (translators for this language)
            main.screen_menu.new_label(_("Translators").decode(main.CODING), 500, p_y); p_y += main.line_spacing
            # Splitting translators to more lines
            translators_list = (main.translators).split("\n")
            for i in range(len(translators_list)):
                main.screen_menu.new_label(translators_list[i], 500, p_y, font_size = 1)
                p_y += main.line_spacing_small
            del translators_list
            
    elif nr == 13:
        main.screen_menu.caption = _("System info").decode(main.CODING)
        main.screen_menu.label_group.empty()
        p_y = 150  # y - position of text - increased after make label
        main.screen_menu.new_label(_("Game").decode(main.CODING), 500, p_y); p_y += main.line_spacing
        main.screen_menu.new_label(_("Name: ").decode(main.CODING) + main.NAME, 500, p_y, font_size = 1); p_y += main.line_spacing_small
        main.screen_menu.new_label(_("Version: ").decode(main.CODING) + main.VERSION, 500, p_y, font_size = 1); p_y += main.line_spacing_small
        main.screen_menu.new_label(_("Year: ").decode(main.CODING) + main.YEAR, 500, p_y, font_size = 1); p_y += main.line_spacing_small
        main.screen_menu.new_label(_("Language: ").decode(main.CODING) + main.language, 500, p_y, font_size = 1)  # Getting lang even if auto selected (zjištěno z LANGUAGE, LC_ALL, LC_MESSAGES nebo LANG(Linux) - zjistit existenci jedné z prom ve WinXP os.getenv(prom) - pokud je XP prom prostř. s jazykem - využít pro autodetekci jazyka)
        try:  # An error occurs on Windows XP sometimes, but it's not so imporant information
            p_y += main.line_spacing_small
            main.screen_menu.new_label(_("Working directory: ").decode(main.CODING) + os.getcwd().decode(main.CODING), 500, p_y, font_size = 1)
            p_y += main.line_spacing_small
            main.screen_menu.new_label(_("Saving directory: ").decode(main.CODING) + main.save_dir, 500, p_y, font_size = 1)
        except:
            pass
        p_y += 2 * main.line_spacing
        main.screen_menu.new_label(_("OS").decode(main.CODING), 500, p_y); p_y += main.line_spacing
        main.screen_menu.new_label(_("Platform: ").decode(main.CODING) + platform.platform(), 500, p_y, font_size = 1)
        p_y += main.line_spacing_small
        
    elif nr == 19:
        main.screen_menu = Menu_screen()
        
def return_to_game_screen(cls_nm):
    """
    Returns screen which you should go from cls_nm screen to.
    """
    if cls_nm == "Info_screen" or cls_nm == "Question_exit_screen":
        return Menu_screen()
    else:   # return to game
        return None

class Label(pygame.sprite.Sprite):
    def __init__(self, text = "Label", pos_x = 0, pos_y = 0, act = None, align = 2, font_size = 2):
        pygame.sprite.Sprite.__init__(self)
        if font_size == 1:
            psm = main.pismo_small
        elif font_size == 2:
            psm = main.pismo
        elif font_size == 3:
            psm = main.pismo_big
            
        self.act = ""
        t = text.split(" ")
        for i in range(len(t)):
            if t[i].rfind("http://") != -1 or t[i].rfind("https://") != -1 or t[i].rfind("@") != -1:
                t[i] = t[i].replace("(", "").replace(")","").replace('"','')
                if t[i].rfind("@") != -1:
                    t[i] = "mailto://" + t[i]
                self.act = t[i]
                
                
        self.action = act
        if self.act == "":
            self.col = main.font_color
        else:
            self.col = main.font_color_link
        self.text = text
        self.align = align
        self.image = psm.render(self.text, 1, self.col)
        self.rect = self.image.get_rect()
        if align == 1:
            self.rect.midleft = (pos_x, pos_y)
        elif align == 2:
            self.rect.center = (pos_x, pos_y)
        elif align == 3:
            self.rect.midright = (pos_x, pos_y)
            
    def execute(self):
        if self.act != "":
            webbrowser.open(self.act)

class Menu_item(pygame.sprite.Sprite):
    def __init__(self, text = "Item", pos_x = 0, pos_y = 0, act = None, align = 2, font_size = 2):
        pygame.sprite.Sprite.__init__(self)
        if font_size == 1:
            psm = main.pismo_small
        elif font_size == 2:
            psm = main.pismo
        elif font_size == 3:
            psm = main.pismo_big
        self.action = act
        self.col = main.font_color
        self.fnt_sz = font_size
        self.text = text
        self.align = align
        self.image = psm.render(self.text, 1, main.font_color)
        self.rect = self.image.get_rect()
        if align == 1:
            self.rect.midleft = (pos_x, pos_y)
        elif align == 2:
            self.rect.center = (pos_x, pos_y)
        elif align == 3:
            self.rect.midright = (pos_x, pos_y)
        
    def change(self, text = None, pos_x = None, pos_y = None, col = None):
        px = self.rect.centerx  # Remember current positions
        py = self.rect.centery  # -//-
        
        if self.fnt_sz == 1:
            psm = main.pismo_small
        elif self.fnt_sz == 2:
            psm = main.pismo
        elif self.fnt_sz == 3:
            psm = main.pismo_big
        
        if col != None:
            self.col = col
        if text != None:
            self.text = text
        if pos_x != None and pos_y != None:
            px = pos_x
            py = pos_y
            
        self.image = psm.render(self.text, 1, self.col)
        self.rect = self.image.get_rect()
        self.rect.center = (px, py)
        

class Quest_box(pygame.sprite.Sprite):
    def __init__(self, nr, val, n, pos_x = 100, pos_y = 100):
        pygame.sprite.Sprite.__init__(self)
        self.number = nr
        self.value = val
        self.quest_name = n
        self.image = Quest_screen.imgs[val + 1]
        self.rect = self.image.get_rect()
        self.rect.left = pos_x
        self.rect.top = pos_y

class Default_screen:

    def __init__(self):
        self.items = []
        self.item_group = pygame.sprite.RenderPlain()
        self.label_group = pygame.sprite.RenderPlain()
        self.pozadi = (pygame.Surface(main.obrazovka.get_size())).convert_alpha()
        main.klavesa = [0, 0, 0, 0, 0, 0]
        main.mouse_move = 0

    def update(self):
        self.item_group.draw(self.pozadi)
        self.label_group.draw(self.pozadi)

    def event_loop(self):
        pass

    def event_loop_def(self, ev):
        """This class provides default events for various screens."""
    
        if ev.type == QUIT:
            if main.term:
                print (_("Termination...").decode(main.CODING))
            game_exit()       
        
        # Menu controls with mouse
        elif ev.type == MOUSEBUTTONDOWN:
            if ev.button == 3:  # right click everywhere
                main.screen_menu = return_to_game_screen(main.screen_menu.__class__.__name__)
        
            elif ev.button == 1:
#                for i in range(len(self.items)):  # every range(len(self.items)) should be replaced by self.item_group; 
                                                   # self.active_item replace by group with one sprite
#                    if self.items[i].rect.collidepoint(pygame.mouse.get_pos()):
#                        menu_action(self.items[i].action)
                        
                for i in self.item_group:   # click on normal menu item
                    if i.rect.collidepoint(pygame.mouse.get_pos()):
                        menu_action(i.action)

                for i in self.label_group:  # click on label in menu
                    if i.rect.collidepoint(pygame.mouse.get_pos()):
                        i.execute()    # works only for labels with URL or e-mail

                            
        elif ev.type == MOUSEMOTION:
            for i in range(len(self.items)):
                if self.items[i].rect.collidepoint(pygame.mouse.get_pos()):
                    for j in range(len(self.items)):
                        self.items[j].change(col = main.font_color)
                    self.items[i].change(col = main.font_color_active)
                    self.active_item = i
        
        elif ev.type == KEYDOWN:
        
            if ev.key == K_ESCAPE:
                main.screen_menu = return_to_game_screen(main.screen_menu.__class__.__name__)
                
            elif ev.key == main.ovladaci_klavesy[11]:
                data.make_screenshot()
                
        # menu controls with keys
            if ev.key == main.ovladaci_klavesy[4]:
                if len(self.items) > 0:
                    self.active_item += 1
                    if self.active_item >= len(self.items):
                        self.active_item = 0
                        
                    for i in range(len(self.items)):
                        self.items[i].change(col = main.font_color)
                    self.items[self.active_item].change(col = main.font_color_active)
                
            elif ev.key == main.ovladaci_klavesy[2]:
                if len(self.items) > 0:
                    self.active_item -= 1
                    if self.active_item < 0:
                        self.active_item = len(self.items) - 1
                        
                    for i in range(len(self.items)):
                        self.items[i].change(col = main.font_color)
                    self.items[self.active_item].change(col = main.font_color_active)
                    
            elif ev.key == main.ovladaci_klavesy[9] or ev.key == K_RETURN:
                menu_action(self.items[self.active_item].action)
                
    def mouse_on_item_detection(self):
        """Jump with mouse away and back. Generates mouse move event; selects menu item
        without real mouse motion. Should be in every screen which generates menu items."""
        p = pygame.mouse.get_pos()
        pygame.mouse.set_pos((0, 0))
        pygame.mouse.set_pos((p))
                
    def new_item(self, text = "Item", pos_x = 0, pos_y = 0, act = None, align = 2, font_size = 2):  # align 1 - left, 2 - center, 3 - right
#        self.t = text
#        self.px = pos_x
#        self.py = pos_y
        
        self.items.append(Menu_item(text, pos_x, pos_y, act, align, font_size))
        self.item_group.add(self.items[-1])
        
    def new_label(self, text = "Item", pos_x = 0, pos_y = 0, act = None, align = 2, font_size = 2):  # align 1 - left, 2 - center, 3 - right
        self.label_group.add(Label(text, pos_x, pos_y, act, align, font_size))
#        return self.label_group.sprites()[-1]
        

class Menu_screen(Default_screen):  # Screen with main menu
    def __init__(self):
        Default_screen.__init__(self)
        self.new_item(_("Play").decode(main.CODING), main.SCREEN_WIDTH / 2, 200, act = 1)
        self.active_item = 0
        self.items[self.active_item].change(col = main.font_color_active)
        self.new_item(_("Info").decode(main.CODING), main.SCREEN_WIDTH / 2, 250, act = 3)
        self.new_item(_("Exit").decode(main.CODING), main.SCREEN_WIDTH / 2, 300, act = 4)
        self.mouse_on_item_detection()
        
    def update(self):
        self.pozadi.fill(main.back_color)
        
        text = main.pismo_big.render(main.NAME, 1, main.font_color)
        self.pozadi.blit(text, (20, 10))
        
        Default_screen.update(self)
        
        text = main.pismo_small.render(main.VERSION, 1, main.font_color)
        text_pos = text.get_rect()
        text_pos.bottomleft = (10, main.SCREEN_HEIGHT - 5)
        self.pozadi.blit(text, text_pos)
        
        text = main.pismo_small.render(((u"(C) {0} Lukáš Machyán ({1})").format(main.YEAR, main.AUTHOR)), 1, main.font_color)
        text_pos = text.get_rect()
        text_pos.bottomright = (main.SCREEN_WIDTH - 10, main.SCREEN_HEIGHT - 5)
        self.pozadi.blit(text, text_pos)
        
    def event_loop(self):
        for udalost in pygame.event.get():
            self.event_loop_def(udalost)   # Call default screen menu event loop
        
class Quest_screen(Default_screen):
    def __init__(self):
#        self.item = 0
        Default_screen.__init__(self)
        
        self.quest_box = []
#        self.quest_box2 = []
        self.box_group = pygame.sprite.RenderPlain()
        
        self.__class__.imgs = data.nahrat_obrazky("checkbox%d.png")
        self.img_shine = data.nahrat_obrazek("shine.png")
        
        self.k = main.quest.keys()
        
        self.generate_quest_boxes()
        
    def __del__(self):
        try:
            for i in range(len(self.k)):
                if self.k[i] in main.quest:
                    if main.quest[self.k[i]] == -1:
                        main.quest[self.k[i]] = 0
        except:
            pass
        
    def generate_quest_boxes(self, st = 0):
        od = st
        do = od + 20  # 20 - Number of quests on one screen
        
        if do > len(self.k):
            do = len(self.k)
        
        x1 = 50
        y1 = 100
        
        for i in range(od, do):
            # Position calculating
            x = x1
            y = y1
            
            if x1 > 250:
                y1 += 100
                x1 = 50
            else:
                x1 += 100
            
            # Create quest_box and add it to box_group
            self.quest_box.append(Quest_box(i, main.quest[self.k[i]], self.k[i], pos_x = x, pos_y = y))
            self.box_group.add(self.quest_box[len(self.quest_box) - 1])
    
    def update(self):
        self.pozadi.fill(main.back_color_objectives)
        shine_pos = None
        
        for i in range(len(self.quest_box)):
#            col = (255, 0, 0)
            
            if self.quest_box[i].rect.collidepoint(pygame.mouse.get_pos()):
#                col = (0, 255, 255)
                shine_pos = (self.quest_box[i].rect.center[0] - 65, self.quest_box[i].rect.center[1] - 65)
                
                text = main.pismo.render(main.quest_texts[str(self.quest_box[i].quest_name) + "0"], 1, main.font_color)
                self.pozadi.blit(text, (50, 420))
                
                if self.quest_box[i].value >= 1:
                    text = main.pismo.render(main.quest_texts[str(self.quest_box[i].quest_name) + "1"], 1, main.font_color)
                    self.pozadi.blit(text, (50, 450))
                
#            pygame.draw.rect(self.pozadi, col, self.quest_box[i][1], 1)

        text = main.pismo_big.render(_("List of objectives").decode(main.CODING), 1, main.font_color)
        self.pozadi.blit(text, (20, 20))
#        text = main.pismo.render(str(self.item), 1, (255, 60, 10))
#        self.pozadi.blit(text, (0 + main.SCREEN_WIDTH/2, 0))
        self.box_group.draw(self.pozadi)
        if shine_pos != None:
            self.pozadi.blit(self.img_shine, shine_pos)
            
    def event_loop(self):
        for udalost in pygame.event.get():
            self.event_loop_def(udalost)   # Call default screen menu event loop    
        
            if udalost.type == KEYDOWN:    # + Do event loop specific event loop only for this screen
                    
                if udalost.key == K_TAB:
                    main.screen_menu = None
                        
#                elif udalost.key == main.ovladaci_klavesy[2]:
#                    self.item -= 1
#                elif udalost.key == main.ovladaci_klavesy[4]:
#                    self.item += 1
                    
class Debug_screen(Default_screen):
    def __init__(self):
        Default_screen.__init__(self)
        self.bod1 = None
        self.bod2 = None
        self.stisk = 0
        self.stisk2 = 0
        
    def update(self):
        self.pozadi.fill((100, 100, 35, 50))
        
        if self.stisk == 1:  # drawing of rect
            self.bod2 = pygame.mouse.get_pos()
        
        if self.bod1 != None and self.bod2 != None:
            pygame.draw.rect(self.pozadi, main.font_color, (self.bod1, (self.bod2[0] - self.bod1[0], self.bod2[1] - self.bod1[1])), 1)
            text = main.pismo.render("rect: " + str((self.bod1, (self.bod2[0] - self.bod1[0], self.bod2[1] - self.bod1[1]))), 1, main.font_color)
            self.pozadi.blit(text, (20, 20))
            
        if self.stisk2 == 1:  # moving of subjects
            for i in range(len(main.group[main.active_room].sprites())):
                if main.group[main.active_room].sprites()[i].rect.collidepoint(pygame.mouse.get_pos()):
                    main.group[main.active_room].sprites()[i].rect.center = pygame.mouse.get_pos()
            text = main.pismo.render("mouse pos: " + str(pygame.mouse.get_pos()), 1, main.font_color)
            self.pozadi.blit(text, (640, 20))
            
    
    def event_loop(self):
        for udalost in pygame.event.get():
            self.event_loop_def(udalost)
            if udalost.type == MOUSEBUTTONDOWN:
                if udalost.button == 1:
                    self.stisk = 1
                    self.bod1 = pygame.mouse.get_pos()
                elif udalost.button == 2:
                    self.stisk2 = 1
                    
            if udalost.type == MOUSEBUTTONUP:
                if udalost.button == 1:
                    self.stisk = 0
                elif udalost.button == 2:
                    self.stisk2 = 0
                    
#            if udalost.type == KEYDOWN: # Doesn't work
#                if self.bod1 != None:
#                    if udalost.key == K_LEFT:
#                        self.bod1[0] = self.bod1[0] - 5
                    
                    
class Error_screen(Default_screen):
    def __init__(self, s = "", nr = 0):
        Default_screen.__init__(self)
        self.s = s
        self.nr = nr
        
    def update(self):
        self.pozadi.fill(main.back_color_error)
    
        text = main.pismo_big.render(_("Error").decode(main.CODING), 1, main.font_color)
        self.pozadi.blit(text, (20, 20))
        
                
        if self.nr == 1:
#            st = _("An error occurred during loading image %s" % os.path.join(os.getcwdu(),self.s))
            text = main.pismo.render(_("An error occurred during loading following image:").decode(main.CODING), 1, main.font_color)
            pos = text.get_rect()
            pos.centerx = main.SCREEN_WIDTH/2
            pos.top = 100
            self.pozadi.blit(text, pos)
            
            text = main.pismo.render(os.path.join(os.getcwdu(),self.s), 1, main.font_color)
            pos = text.get_rect()
            pos.centerx = main.SCREEN_WIDTH/2
            pos.top = 150
            self.pozadi.blit(text, pos)
            
            text = main.pismo.render(_("Check if file exists, if isn't damaged and if you have permisions to read it.").decode(main.CODING), 1, main.font_color)
            pos = text.get_rect()
            pos.centerx = main.SCREEN_WIDTH/2
            pos.top = 200
            self.pozadi.blit(text, pos)
            
            text = main.pismo.render(_("Click or press any key to terminate program.").decode(main.CODING), 1, main.font_color)
            pos = text.get_rect()
            pos.centerx = main.SCREEN_WIDTH/2
            pos.top = 250
            self.pozadi.blit(text, pos)
            
        else:
            text = main.pismo.render(_("Unknown error").decode(main.CODING), 1, main.font_color)
            pos = text.get_rect()
            pos.centerx = main.SCREEN_WIDTH/2
            pos.top = 150
            self.pozadi.blit(text, pos)
    
    def event_loop(self):
#        for udalost in pygame.event.get():                    
#            if udalost.type == MOUSEBUTTONDOWN or udalost.type == KEYDOWN or udalost.type == QUIT:
#                if main.term:
#                    print (_("Termination..."))
#                exit()

        ev = pygame.event.wait()
        if ev.type == MOUSEBUTTONDOWN or ev.type == KEYDOWN or ev.type == QUIT:
            if main.term:
                print (_("Termination...").decode(main.CODING))
            exit()

class Info_screen(Default_screen):
    def __init__(self):
        Default_screen.__init__(self)
        self.new_item(_("License").decode(main.CODING), 20, 200, act = 11, align = 1)
        self.active_item = 0
        self.caption = _("Info").decode(main.CODING)
        self.items[self.active_item].change(col = main.font_color_active)
        self.new_item(_("Credits").decode(main.CODING), 20, 250, act = 12, align = 1)
        self.new_item(_("System info").decode(main.CODING), 20, 300, act = 13, align = 1)
        self.new_item(_("Back").decode(main.CODING), 20, 350, act = 19, align = 1)
        self.mouse_on_item_detection()
        
    def update(self):
        self.pozadi.fill(main.back_color)
        
        text = main.pismo_big.render(self.caption, 1, main.font_color)
        pos = (20, 10)
        self.pozadi.blit(text, pos)
        
        Default_screen.update(self)
                
    def event_loop(self):
        for udalost in pygame.event.get():
            self.event_loop_def(udalost)
            
class Question_exit_screen(Default_screen):
    def __init__(self):
        Default_screen.__init__(self)
        self.new_label(_("Are you sure you want to exit this game?").decode(main.CODING), main.SCREEN_WIDTH/2, 150,)
        self.new_item(_("Yes").decode(main.CODING), main.SCREEN_WIDTH/2, 250, act = 0)
        self.active_item = 0
        self.new_item(_("No").decode(main.CODING), main.SCREEN_WIDTH/2, 300, act = 19)
        self.items[self.active_item].change(col = main.font_color_active)
        self.mouse_on_item_detection()
        
    def update(self):
        self.pozadi.fill(main.back_color_question)
        
        Default_screen.update(self)
                
    def event_loop(self):
        for udalost in pygame.event.get():
            self.event_loop_def(udalost)
            

        
#class Quest_screen:
#    def __init__(self):
#        self.item = 0    
#    
#        self.pozadi = (pygame.Surface(main.obrazovka.get_size())).convert_alpha()
##        self.pozadi.fill((30, 150, 35, 150)) # ((50, 50, 90)) - modř
##        
##        text = main.pismo.render(str(main.sova.frame), 1, (255, 60, 10))
##        self.pozadi.blit(text, (0 + main.SCREEN_WIDTH/2, 0))
#        
#    def update(self):
#        self.pozadi.fill((30, 150, 35, 150))    
#    
#        text = main.pismo.render(str(self.item), 1, (255, 60, 10))
#        self.pozadi.blit(text, (0 + main.SCREEN_WIDTH/2, 0))
