# -*- coding: utf-8 -*-
#
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
#  Noctua vagus - An adventure game with an owl as a main character         # .
#  Copyright (C) 2010  Lukáš Machyán (Phobulos@gmail.com)                   # .
#                                  (http://phobulos.wz.cz)                  # .
#                                                                           # .
#  This program is free software: you can redistribute it and/or modify     # .
#  it under the terms of the GNU General Public License as published by     # .
#  the Free Software Foundation, either version 3 of the License, or        # .
#  (at your option) any later version.                                      # .
#                                                                           # .
#  This program is distributed in the hope that it will be useful,          # .
#  but WITHOUT ANY WARRANTY; without even the implied warranty of           # .
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            # .
#  GNU General Public License for more details.                             # .
#                                                                           # .
#  You should have received a copy of the GNU General Public License        # .
#  along with this program. If not, see <http://www.gnu.org/licenses/>.     # .
#                                                                           # .
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # .
# . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .

import pygame, os, random
from pygame.locals import *

import data, main, calc
#from main import *

class Sova(pygame.sprite.Sprite):

    def __init__(self):
        pygame.sprite.Sprite.__init__(self)
        self.image = data.nahrat_obrazek("sova00.png")
        self.rect = self.image.get_rect()
        self.obrazky = data.nahrat_obrazky("sova0%d.png")    # standard images
        self.obrazky_h = data.nahrat_obrazky("sova0%dh.png") # hooting owl
        
        self.frame = 0

        self.delay = 8
        self.delay_center = 8
        self.delay_up = 4
        self.delay_side = 6
        self.delay_down = 10
        
        self.cas_houkani = 0
        self.hooting_sequence = []
        self.hooting_seq_time = 0

        self.pause = 0
        self.smer_anim = 1
        self.naklon = 0

        self.VYSOKA_RYCHLOST = 8
        self.NORMALNI_RYCHLOST = 4
        self.rychlost = self.NORMALNI_RYCHLOST
        self.hspeed = 0
        self.max_naklon = 6
        self.houkani = 0
        self.inventory = -1
        self.moving = 0  # self.move() function sets this; variable should report if the owl is moving
                         # Now it shows True in case of attempt to move (moving is blocked by an obstacle)
        self.info_message_time = 0
        
        self.rect.center = (250, 200)

    def update(self):
    
        # Animation
        self.pause += 1
        if self.pause >= self.delay:
            #reset pause and advance animation
            self.pause = 0
            self.frame += self.smer_anim
            if self.frame >= len(self.obrazky):
                self.smer_anim = -1
                self.frame -= 2
            if self.frame <= -1:
                self.smer_anim = 1
                self.frame += 2
#                main.snd_wingflap.play()  # wing flap sound
            if self.naklon == 0:
                if self.houkani:
                    self.image = self.obrazky_h[self.frame]
                else:
                    self.image = self.obrazky[self.frame]
            else:
                if self.houkani:
                    self.image = pygame.transform.rotate(self.obrazky_h[self.frame], self.naklon)
                else:
                    self.image = pygame.transform.rotate(self.obrazky[self.frame], self.naklon)
                    
        if self.houkani:
            self.cas_houkani -= 1
            if self.cas_houkani <= 0:
                self.houkani = 0
               
        if self.hooting_seq_time > 0:
            self.hooting_seq_time -= 1
        elif len(self.hooting_sequence) > 0:
            sequ = len(self.hooting_sequence)
            print self.hooting_sequence
            # odstranění duplicit ze sekvence a seřazení
            for i in range(sequ-1, -1, -1):
                if self.hooting_sequence.count(self.hooting_sequence[i]) > 1:
                    del self.hooting_sequence[i]
            self.hooting_sequence.sort()
            print self.hooting_sequence
            
            # odeslání vyhoukaného symbolu zde
            # projetí tvorů v tomto roomu ve stylu hledání nejbližšího předmětu; každý tvor bude mít metodu, co se provede po přijetí houkání; odsud se bude volat metoda nejbližšího tvora v místnosti (nebo všech?)
            
            sequ = len(self.hooting_sequence)
            for i in range(sequ-1, -1, -1):
                del self.hooting_sequence[i]
                
        # Timing for info messages
        if self.info_message_time > 0:
            self.info_message_time -= 1
        elif main.info_message != "":
            main.info_message = ""            
                    
    def hoot(self, cas, nr):
        if not self.houkani:
            self.houkani = 1   
            self.cas_houkani = cas
            main.houkani[nr].play()
#            if self.hooting_sequence.count(nr*10) <= 0: # Toto omezení nemá význam pokud se přidají posunutá houkání - může to znemožnit jejich úpravu (popř.: určení posunutí houkání myší)
            self.hooting_sequence.append(nr*10)
            self.hooting_seq_time = 120
            
    def move_hooting_embl(self, pr, na, le, do):
        if len(self.hooting_sequence) > 0:
            if self.hooting_sequence[-1] % 10 == 0:
                if pr:
                    self.hooting_sequence[-1] += 1
                if na:
                    self.hooting_sequence[-1] += 2
                if le:
                    self.hooting_sequence[-1] += 3
                if do:
                    self.hooting_sequence[-1] += 4
            
    def move(self, pr, na, le, do, sh = 0):
    
        self.moving = 0

        # modifikace rychlosti
        if sh:
            self.rychlost = self.VYSOKA_RYCHLOST * (main.max_fps/main.fps)
        else:
            self.rychlost = self.NORMALNI_RYCHLOST * (main.max_fps/main.fps)
    
        self.hspeed = 0
        
        if pr:
            self.rect.left = self.rect.left + self.rychlost
            self.hspeed += self.rychlost
            self.moving = 1
            if self.block_collision():
                self.rect.left = self.rect.left - self.rychlost
                self.hspeed -= self.rychlost
            
            if self.rect.right > main.SCREEN_WIDTH + self.rect.width/2 - 20:
                main.room[main.active_room].leave(1)
        if na:
            self.rect.top = self.rect.top - self.rychlost
            self.moving = 1
            if self.block_collision():
                self.rect.top = self.rect.top + self.rychlost
            if self.rect.top < -self.rect.height/2 + 20:
                main.room[main.active_room].leave(2)
        if le:
            self.rect.left = self.rect.left - self.rychlost
            self.hspeed -= self.rychlost
            self.moving = 1
            if self.block_collision():
                self.rect.left = self.rect.left + self.rychlost
                self.hspeed += self.rychlost
                
            if self.rect.left < -self.rect.width/2 + 20:
                main.room[main.active_room].leave(3)
        if do:
            self.rect.top = self.rect.top + self.rychlost
            self.moving = 1
            if self.block_collision():
                self.rect.top = self.rect.top - self.rychlost
            if self.rect.bottom > main.SCREEN_HEIGHT + self.rect.height/2 - 20:
                main.room[main.active_room].leave(4)
                
        self.sprite_appear(pr, na, le, do, sh)
        
    def block_collision(self):
        # check collision of any block2
        if len(main.room[main.active_room].block2) > 0:
            for i in range(len(main.room[main.active_room].block2)):
                if self.rect.colliderect(main.room[main.active_room].block2[i]):
                    return 1
                else:
                    return 0

    def move2(self, pos):
        pr1, na1, le1, do1 = 0, 0, 0, 0
        if self.rect.centerx < pos[0] - self.NORMALNI_RYCHLOST:
            pr1 = 1
        elif self.rect.centerx > pos[0] + self.NORMALNI_RYCHLOST:
            le1 = 1
        
        if self.rect.centery > pos[1] + self.NORMALNI_RYCHLOST:
            na1 = 1
        elif self.rect.centery < pos[1] - self.NORMALNI_RYCHLOST:
            do1 = 1
            
        self.move(pr1, na1, le1, do1, main.klavesa[5])
        self.sprite_appear(pr1, na1, le1, do1, main.klavesa[5])
    
    def sprite_appear(self, pr, na, le, do, sh = 0):
                
        # změna náklonu
        if pr and le:
            self.naklon = 0
        elif pr:
            self.naklon = -self.max_naklon
        elif le:
            self.naklon = self.max_naklon
        else:
            self.naklon = 0

        # changing animation delay according to direction of motion
        if na and do:
            self.delay = self.delay_center
        elif na:
            self.delay = self.delay_up
        elif pr and le:
            self.delay = self.delay_center
        elif pr:
            self.delay = self.delay_side
        elif le:
            self.delay = self.delay_side
        elif do:
            self.delay = self.delay_down
        else:
            self.delay = self.delay_center
            
        # lower animation delay when is "speed key" pressed
        if sh:
            self.delay = (self.delay * self.NORMALNI_RYCHLOST) / self.VYSOKA_RYCHLOST

    def stop(self, sm):
        "Stop owl when there is no exit from room in particular direction."
        pr1 = na1 = le1 = do1 = 0
        if sm == 1:
            le1 = 1
        elif sm == 2:
            do1 = 1
        elif sm == 3:
            pr1 = 1
        elif sm == 4:
            na1 = 1
            
        self.move(pr1, na1, le1, do1, main.klavesa[5])

    def take_drop(self):
        if self.inventory == -1:   # picking subject
            nejblA = None
            vzdalA = 10000
            
            for i in range(len(main.obj)):
                vzdal = calc.distance(self.rect.midbottom, main.obj[i].rect.center)
                if vzdal < 50:
                    if main.obj[i].is_in_room(main.active_room) and main.obj[i].pickable:
                        if vzdal < vzdalA:
                            nejblA = i
                            vzdalA = vzdal
                # In this loop should be cycling in range main.group[main.active] but self.inventory 
                # must get index of object in main.obj. Changing self.inventory to "in owl_group" could
                # solved this.
            
            if nejblA != None:
                # remove from current room and add to inventory
                self.inventory = nejblA   # adding to inventory
                main.owl_group.add(main.obj[nejblA])
                main.group[main.active_room].remove(main.obj[nejblA])
#                main.obj[nejblA].place = None  # old removing
                main.obj[nejblA].falling = 0
                main.obj[nejblA].falling_time = 0
                
        else:   # dropping subject
            main.group[main.active_room].add(main.obj[self.inventory])  # new adding
            main.owl_group.remove(main.obj[self.inventory])
            main.obj[self.inventory].dropped_in = main.active_room
#            main.obj[self.inventory].place = main.room[main.active_room].ide  # old adding
            main.obj[self.inventory].falling = 1
            main.obj[self.inventory].hspeed = self.hspeed
#            main.obj[self.inventory].falling_time = 0
            self.inventory = -1
       
    def wrap(self, d):
        if d == 1:
            self.rect.left -= main.SCREEN_WIDTH
        elif d == 2:
            self.rect.top += main.SCREEN_HEIGHT
        elif d == 3:
            self.rect.left += main.SCREEN_WIDTH
        elif d == 4:
            self.rect.top -= main.SCREEN_HEIGHT
    
#        if self.rect.right > main.SCREEN_WIDTH:
#            self.rect.left -= main.SCREEN_WIDTH
#        elif self.rect.top < 0:
#            self.rect.top += main.SCREEN_HEIGHT
#        elif self.rect.left < 0:
#            self.rect.left += main.SCREEN_WIDTH
#        elif self.rect.bottom > main.SCREEN_HEIGHT:
#            self.rect.top -= main.SCREEN_HEIGHT
            
class Predmet(pygame.sprite.Sprite):
    obrazky = None
    
    def __init__(self, pos = None, pick = 1, embl = None, ani_rew = 1):
        pygame.sprite.Sprite.__init__(self)
        self.ide = len(main.obj)
#        self.init_cont()
        
        if self.__class__.obrazky == None:
            self.__class__.obrazky = data.nahrat_obrazky(self.img_name)
        if self.__class__.obrazky != None and len(self.__class__.obrazky) > 0:
            self.rect = self.__class__.obrazky[0].get_rect()
            self.image = self.__class__.obrazky[0]
            if pos != None:
                self.rect.center = pos
                
        self.emblem = embl
        
#        print self.obrazek # - stejná práce s obrazek jako s image v příkladu
#        print id(self.image) #! Možná by měly být stejné id u různých objektů
        self.falling = 0
        self.falling_time = 0
        self.hspeed = 0
        self.pickable = pick
        self.dropped_in = 0  # Subjects know where have been dropped
            
        # For animation
        self.delay = 20
        self.pause = 0
        self.frame = 0
        self.smer_anim = 1
        self.ani_rew = ani_rew
        
    def update(self):
    
        self.sprite_appear()  # sprite position and appear according owl
        
        if self in main.group[main.active_room] or self in main.owl_group:
            self.update_this()      # Update actions for instances in this room

        if self.falling:  # Subject is falling
            self.falling_time += 1
            self.rect.top += self.falling_time * (main.max_fps/main.fps)
            
            # Outside room horizontally
            if self.rect.centerx >= main.SCREEN_WIDTH: # Outside room horizontally right
                if main.room[self.dropped_in].exits[0] != -1:
                    main.group[self.dropped_in].remove(self)       # move from
                    main.group[main.room[self.dropped_in].exits[0]].add(self) # move to
#                    self.place = main.room[self.place].exits[0]  # old move
                    self.rect.left -= main.SCREEN_WIDTH
                    self.dropped_in = main.room[self.dropped_in].exits[0]
                else: 
                    self.hspeed = 0
            elif self.rect.centerx < 0:                # Outside room horizontally left
                if main.room[self.dropped_in].exits[2] != -1:
                    main.group[self.dropped_in].remove(self)       # move from
                    main.group[main.room[self.dropped_in].exits[2]].add(self) # move to
#                    self.place = main.room[self.place].exits[2]  # old move
                    self.rect.left += main.SCREEN_WIDTH
                    self.dropped_in = main.room[self.dropped_in].exits[2]
                else: 
                    self.hspeed = 0
            
            # Slowing horizontal speed during fall
            if self.hspeed > 0:
                self.hspeed -= 0.1
            elif self.hspeed < 0:
                self.hspeed += 0.1
            if self.hspeed != 0:
                self.rect.left += self.hspeed

            # Outside room vertically
            if self.rect.centery > main.SCREEN_HEIGHT:
            
                self.falling_time = 0
                self.rect.bottom = main.SCREEN_HEIGHT
                
                # Falling through rooms
                cisl = self.dropped_in
                
                while main.room[cisl].exits[3] != -1 and self.falling != 0:
                    main.group[cisl].remove(self)     # move from
                    cisl = main.room[cisl].exits[3]
                    main.group[cisl].add(self)        # move to
                    
#                    place = main.room[cisl].exits[3]  # old move
                    
                    if len(main.room[cisl].block) > 0:
                        for i in range(len(main.room[cisl].block)):
                            if self.rect.centerx > main.room[cisl].block[i][0] and self.rect.centerx < main.room[cisl].block[i][0] + main.room[cisl].block[i][2]:
                                self.falling = 0
                                self.falling_time = 0
                                self.rect.bottom = main.room[cisl].block[i][1]
                                self.special_collision()
                                
                self.falling = 0
                                
            # stop when collides block
            if len(main.room[main.active_room].block) > 0:
                for i in range(len(main.room[main.active_room].block)):
                    if self.rect.colliderect(main.room[main.active_room].block[i]):
                        if self.rect.centery < main.room[main.active_room].block[i][1]:
                            self.falling = 0
                            self.falling_time = 0
                            self.special_collision()
                                
    def update_this(self):
        """This update works only for instances in this room. Called from update method."""
        # Animation
        if len(self.__class__.obrazky) > 1:
            self.pause += 1
            if self.pause >= self.delay:
                #reset pause and advance animation
                self.pause = 0
                self.frame += self.smer_anim
                if self.frame >= len(self.obrazky):
                    if self.ani_rew:  # animation rewinding (e.g. frames: 0, 1, 2, 1, 0)
                        self.smer_anim = -1
                        self.frame -= 2
                    else:             # no animation rewinding (e.g. frames: 0, 1, 2, 0, 1, 2)
                        self.frame = 0
                        
                if self.frame <= -1:
                    self.smer_anim = 1
                    self.frame += 2
                self.image = self.obrazky[self.frame]
                
        # Owl collision
        if self.rect.colliderect(main.sova.rect):
            self.owl_collision()  # What should happen when object collide owl
    
    def is_in_room(self, r):
#        if self.place == main.room[main.active_room].ide:
        if self in main.group[r]:
            return 1
        else:
            return 0
    
    def special_collision(self):
        pass
    
    def sprite_appear(self):
        """Change position and apear of held subject according the owl."""
        if self in main.owl_group:
            if main.sova.naklon > 0:    
                self.rect.centerx = main.sova.rect.centerx + 10  # correction on left direction
            else:
                self.rect.centerx = main.sova.rect.centerx
            self.rect.top = main.sova.rect.bottom - 25 - (main.sova.frame + 1) * 8
        
            # změna náklonu
            if main.sova.naklon == 0:  # pr and le:
                self.image = self.obrazky[self.frame]
            else:
                self.image = pygame.transform.rotate(self.obrazky[self.frame], main.sova.naklon)
                
    def owl_collision(self):
        pass
#        if self.emblem != None:
#            data.draw_emblem(self.image, (self.rect.centerx, self.rect.centery + 100), self.emblem)
            
class Tvor(pygame.sprite.Sprite):
    obrazek = None
    def __init__(self, pos = None, embl = None):
        pygame.sprite.Sprite.__init__(self)
        self.ide = len(main.creature)
#        self.init_cont()
        if self.__class__.obrazek == None:
            self.__class__.obrazek = data.nahrat_obrazek(self.img_name)
        if self.__class__.obrazek != None:
            self.rect = self.__class__.obrazek.get_rect()
            self.image = self.__class__.obrazek
            if pos != None:
                self.rect.center = pos
        self.emblem = embl
                
    def update_this(self):
        pass

# ???            
#class Problem(pygame.sprite.Sprite):

#    def __init__(self):
#        self.obrazek, self.rect = data.nahrat_obrazek("orech.png")
#        self.number = 0 

class Kamen(Predmet):
    def __init__(self, pos = None, pick = 0, embl = None, ani_rew = 1):
        self.img_name = "kamen.png"
        Predmet.__init__(self, pos, pick, embl, ani_rew)

class Hnizdo(Predmet):
    def __init__(self, pos = None, pick = 1, embl = None, ani_rew = 1):
        self.img_name = "hnizdo_front.png"
        Predmet.__init__(self, pos, pick, embl, ani_rew)

class Orech(Predmet):
    def __init__(self, pos = None, pick = 1, embl = None, ani_rew = 1):
        self.img_name = "orech.png"
        Predmet.__init__(self, pos, pick, embl, ani_rew)
        #self.rect.center = (200 + 200 * random.random(), 200)

class Ptace(Predmet):
    def __init__(self, pos = None, pick = 1, embl = None, ani_rew = 1):
        self.img_name = "ptace0%d.png"
        Predmet.__init__(self, pos, pick, embl, ani_rew)

    def special_collision(self):
        """This occurs when subjects ends falling."""
        in_collision = self.rect.collidelistall(main.group[main.active_room].sprites())
        if in_collision > 0:
            for i in in_collision:
                if main.group[main.active_room].sprites()[i].__class__.__name__ == "Hnizdo" and self.pickable == 1:
                    self.pickable = 0
                    self.rect.center = (449, 157)                    
                    data.change_quest_status("little_bird", 1)
                    
    def owl_collision(self):
        Predmet.owl_collision(self)
        if self.pickable == 1:
            data.change_quest_status("little_bird", -1, self.rect.center)
            
class Stream(Predmet):
    def __init__(self, pos = None, pick = 0, embl = None, ani_rew = 1):
        self.img_name = "potok0%d.png"
        Predmet.__init__(self, pos, pick, embl, ani_rew)
        self.delay = 7
        
class Waterfall(Predmet):
    def __init__(self, pos = None, pick = 0, embl = None, ani_rew = 1):
        self.img_name = "vodopad0%d.png"
        Predmet.__init__(self, pos, pick, embl, ani_rew)
        self.delay = 7
        
class Waterfall2(Predmet):
    def __init__(self, pos = None, pick = 0, embl = None, ani_rew = 1):
        self.img_name = "vodopad20%d.png"
        Predmet.__init__(self, pos, pick, embl, ani_rew)
        self.delay = 7
        
class WaterPool(Predmet):
    def __init__(self, pos = None, pick = 0, embl = None, ani_rew = 1):
        self.img_name = "jezirko0%d.png"
        Predmet.__init__(self, pos, pick, embl, ani_rew)
        self.delay = 9
            

class Veverka(Tvor):
    def __init__(self, pos = None, embl = None):
        self.img_name = "veverka.png"
        Tvor.__init__(self, pos, embl)
